
import path from 'path'
import readMetadata from 'read-metadata'
import { Raw } from '../../../../..'

export default function (state) {
  const file = path.resolve(__dirname, 'fragment.yaml')
  const raw = readMetadata.sync(file)
  const fragment = Raw.deserialize(raw).document

  const { document, selection } = state
  const texts = document.getTextNodes()
  const second = texts.get(1)
  const range = selection.merge({
    anchorKey: second.key,
    anchorOffset: 0,
    focusKey: second.key,
    focusOffset: 0
  })

  return state
    .transform()
    .insertFragmentAtRange(range, fragment)
    .apply()
}
